Leetcode[4] Median of two sorted arrays

There are two sorted arrays nums1 and nums2 of size m and n
respectively.

Find the median of the two sorted arrays. The overall run time
complexity should be O(log (m+n)).

Example 1: nums1 = [1, 3] nums2 = [2]

The median is 2.0 Example 2: nums1 = [1, 2] nums2 = [3, 4]

The median is (2 + 3)/2 = 2.5

Binary search

复杂度
O(lg(m + n))

思路
因为要找中位数,又是在两个sorted的数组里面。所以考虑用二分法。(二分法经常适合sorted的array).
接下来考虑如何二分。
假设第k个数是我们要找的中位数,那么前k-1个数应该都比这个第k个数要小。后面的数都比这个第k个数大。(像变形的用二分法找第K个数)。
如果我们每次在a数组中找前(k/2) = m个数,在b数组中找剩下的(k-k/2) = n个数。然后对a[p + k/2 - 1]和b[q + k - k/2 -1]进行比较,记为a[i]和b[j]。

  • a[i] < b[j]: 说明我们可以扔掉0-i之间的(i+ 1)个数。为什么?
    因为a数组中的前m个数的最大值都比b数组中的前n个数要小,那么这前m个数一定是在我们想要的中位数之前的,并且对找到中位数没有说明影响。所以为了缩小搜索范围,我们可以扔掉这些数,在a的剩下来的数中和b的数组中接着找。
  • i>=a.length: 说明a中没有m个数可以寻找。那么第K个数要么在b剩下的数组[n ~ b.length]中,要么就在a的前m个数中。

一直搜索到什么时候为止呢?
k=1代表的是,当前的这个是就是我们想要的值,我们应该在如何选择? Math.min(a[p], b[q]).

if(a[i] < b[j]) {
  search(a[right], b[0], k - m);
} else {
  search (a[0], b[right], k - n);
}

我们从找第K个数开始,一直到K=1,每次扔掉一部分数 k /2,所以时间复杂度是log(k).
K=(M + N) / 2, 所以时间复杂度是log(m + n)

代码

class Solution {
    // 其实找的是第k个值。
    public double findMedianSortedArrays(int[] nums1, int[] nums2) {
        int len = nums1.length + nums2.length;
        if(len % 2 == 0) {
            return findKthNumberInTwoArray(nums1, nums2, 0, 0, len / 2) / 2 
                + findKthNumberInTwoArray(nums1, nums2, 0, 0, len / 2 + 1) / 2;
        } else {
            return findKthNumberInTwoArray(nums1, nums2, 0, 0, len / 2 + 1);
        }     
    }
    
    // p is the start index of nums1, q is the start index of nums2, we wanna find the kth number 
    // in both num1 & nums2
    public double findKthNumberInTwoArray(int[] nums1, int[] nums2, int p, int q, int k) {
        if(p >= nums1.length) return nums2[q + k - 1];
        if(q >= nums2.length) return nums1[p + k - 1];
        if(k == 1) return Math.min(nums1[p], nums2[q]);
        
        int m = k / 2, n = k - m;
        // 因为当a数组没有中这个数的时候,说明第k一定在b数组剩余的数中和a数组的剩余数组中的一个。
        int aVal = Integer.MAX_VALUE, bVal = Integer.MAX_VALUE;
        if(p + m - 1 < nums1.length) aVal = nums1[p + m - 1];
        if(q + n - 1 < nums2.length) bVal = nums2[q + n - 1];
        
        if(aVal < bVal) {
            return findKthNumberInTwoArray(nums1, nums2, p + m, q, k - m);
        } else {
            return findKthNumberInTwoArray(nums1, nums2, p, q + n, k - n);
        }
    }
}

hellolittleJ17
10 声望11 粉丝